//+------------------------------------------------------------------+
//|                                                  Gelium_Days.mq4 |
//+------------------------------------------------------------------+

/*
1.2   close   
1.1         TS 9.1
1.0   Pavik
*/

#property indicator_separate_window
#property indicator_buffers 8
#property indicator_color1  Blue //   
#property indicator_color2  Blue //    
#property indicator_color3  Blue //    
#property indicator_color4  Blue //    
#property indicator_color5  Red  //   
#property indicator_color6  Red  //    
#property indicator_color7  Red  //    
#property indicator_color8  Red  //    

#property indicator_width1  4
#property indicator_width2  1
#property indicator_width3  1
#property indicator_width4  1
#property indicator_width5  4
#property indicator_width6  1
#property indicator_width7  1
#property indicator_width8  1

#property indicator_level2  0
#property indicator_levelstyle STYLE_SOLID
#property indicator_levelcolor DarkSlateGray

double ExtBuffer1[];
double ExtBuffer2[];
double ExtBuffer3[];
double ExtBuffer4[];
double ExtBuffer5[];
double ExtBuffer6[];
double ExtBuffer7[];
double ExtBuffer8[];

int PrevBars; //     

//+------------------------------------------------------------------+

int init()
{
SetIndexStyle(0,DRAW_HISTOGRAM);
SetIndexStyle(1,DRAW_HISTOGRAM);
SetIndexStyle(2,DRAW_HISTOGRAM);
SetIndexStyle(3,DRAW_SECTION);
SetIndexStyle(4,DRAW_HISTOGRAM);
SetIndexStyle(5,DRAW_HISTOGRAM);
SetIndexStyle(6,DRAW_HISTOGRAM);
SetIndexStyle(7,DRAW_SECTION);

IndicatorDigits(Digits+1);

SetIndexBuffer(0,ExtBuffer1);
SetIndexBuffer(1,ExtBuffer2);
SetIndexBuffer(2,ExtBuffer3);
SetIndexBuffer(3,ExtBuffer4);
SetIndexBuffer(4,ExtBuffer5);
SetIndexBuffer(5,ExtBuffer6);
SetIndexBuffer(6,ExtBuffer7);
SetIndexBuffer(7,ExtBuffer8);

IndicatorShortName("Gelium_Days");

SetIndexLabel(0,NULL);
SetIndexLabel(1,NULL);
SetIndexLabel(2,NULL);
SetIndexLabel(3,NULL);
SetIndexLabel(4,NULL);
SetIndexLabel(5,NULL);
SetIndexLabel(6,NULL);
SetIndexLabel(7,NULL);

}

//+------------------------------------------------------------------+

int start()
{
if (Period() > PERIOD_D1)
   {
   Alert("       ");
   return;
   }

int counted_bars = IndicatorCounted();
if (counted_bars > 0) counted_bars--;
int limit = Bars - counted_bars;  //   ,    

int minlimit = 1440/Period() + 3; //  - ,    
if (limit<minlimit) limit=minlimit;

int body, shadowU, shadowD;       //  ,  ,    
double open=0,high=0,low=999999,close=0;

for (int i = limit-1; i > 0; i--) //      
   {
   if (High[i] > high) high=High[i];
   if (Low[i] < low) low=Low[i];
   if (TimeDay(Time[i]) != TimeDay(Time[i-1])) //     
      {
      close = Close[i];
      if ((open != 0) && (high != 0) && (low != 999999)) //     - 
         {
         body = MathAbs(close-open) / Point;
         if (open < close) //   
            {
            shadowU = (high-low) / Point;
            shadowD = (open-low) / Point;
            ExtBuffer4[i] = shadowU;  //    
            ExtBuffer8[i] = -shadowD; //    
            ExtBuffer1[i] = body;     //  
            ExtBuffer2[i] = shadowU;  //   
            ExtBuffer3[i] = -shadowD; //   
            }
         if (open > close) //   
            {
            shadowU = (high-open) / Point;
            shadowD = (high-low) / Point;
            ExtBuffer4[i] = shadowU;  //    
            ExtBuffer8[i] = -shadowD; //    
            ExtBuffer5[i] = -body;    //  
            ExtBuffer6[i] = shadowU;  //   
            ExtBuffer7[i] = -shadowD; //   
            }
         }
      open=Open[i-1]; high=0; low=999999; close=0;
      }
   }

i = 0; //   ()   -

if (High[i] > high) high=High[i];
if (Low[i] < low) low=Low[i];
close = Close[i];

//   -
if ((open != 0) && (high != 0) && (low != 999999))
   {
   body = MathAbs(close-open) / Point;
   if (open < close) //   
      {
      shadowU = (high-low) / Point;
      shadowD = (open-low) / Point;
      ExtBuffer4[i] = shadowU;  //    
      ExtBuffer8[i] = -shadowD; //    
      ExtBuffer1[i] = body;     //  
      ExtBuffer2[i] = shadowU;  //   
      ExtBuffer3[i] = -shadowD; //   
      }
   if (open > close) //   
      {
      shadowU = (high-open) / Point;
      shadowD = (high-low) / Point;
      ExtBuffer4[i] = shadowU;  //    
      ExtBuffer8[i] = -shadowD; //    
      ExtBuffer5[i] = -body;    //  
      ExtBuffer6[i] = shadowU;  //   
      ExtBuffer7[i] = -shadowD; //   
      }
   }

if (PrevBars != Bars) //    
   {
   PrevBars = Bars;
   if (Period() < PERIOD_D1) //    ,   -   
      {
      ExtBuffer1[1] = EMPTY_VALUE;
      ExtBuffer2[1] = EMPTY_VALUE;
      ExtBuffer3[1] = EMPTY_VALUE;
      ExtBuffer4[1] = EMPTY_VALUE;
      ExtBuffer5[1] = EMPTY_VALUE;
      ExtBuffer6[1] = EMPTY_VALUE;
      ExtBuffer7[1] = EMPTY_VALUE;
      ExtBuffer8[1] = EMPTY_VALUE;
      }
   }

}

//+------------------------------------------------------------------+


