//+------------------------------------------------------------------+
//|                                             CCI-Renko-Script.mq4 |
//|                                   Hakan SARI sistemliborsaci.com |
//|                                  https://www.sistemliborsaci.com |
//+------------------------------------------------------------------+
#property copyright "Hakan SARI sistemliborsaci.com"
#property link      "https://www.sistemliborsaci.com"
#property version   "1.00"
#property strict
#property show_inputs

int magic = 0;
input int ana_trend = 0;
input int kac_hata_sonra = 0;
input double sabit_lot = 0.01;
input double risk = 1;
input double max_lot = 10;
input int hedge = 1;
input int lot_model = 1;
input double lot_kati = 0.02;
input double sl = 40;
input double tp = 38;

input int cci = 6;
input int cci_gecikme = 1;

input int calisma_basla = 0;
input int calisma_bitis = 24;

input int interval = 500;
input int point = 10;


int eskitrend = 0;

int hedge_id = 0;

double last_zarar = 0;
double last_lot_zarar = 0;


         double tarama_price = 0;
         double tarama_yon = 0;
         int kac_hata = 0;

int hatasayac = 0;

void OnStart()
  {
//---


   while(IsStopped() == false ) {

   RefreshRates();


   trailing();

   double icci = iCustom(Symbol(),Period(),"CCI",cci,0,cci_gecikme);

   int trend = 0;
   string strend = "";

   if(icci>0) {
      trend = 1;
      strend = "BUY";
   } else if(icci<0) {
      trend = -1;
      strend = "SELL";
   }
         
      double clot = Lots;   
      
      // if(last_lot_zarar == 0) last_lot_zarar = clot;
      
      int hgb = OrderSelect(hedge_id,SELECT_BY_TICKET);
      int hdc_id = OrderTicket();
      int hdc_type = OrderType();
      double hdc_lot = OrderLots();
      double hdc_open = OrderOpenPrice();
      double hdc_sl = OrderStopLoss();
      datetime hdc_closetime = OrderCloseTime();      
      

      
      int gb = OrderSelect(oidi,SELECT_BY_TICKET);
      int dc_id = OrderTicket();
      int dc_type = OrderType();
      double dc_lot = OrderLots();
      double dc_open = OrderOpenPrice();
      double dc_sl = OrderStopLoss();
      double dc_tp = OrderStopLoss();
      double dc_close = OrderStopLoss();
      datetime dc_closetime = OrderCloseTime();


      if(hdc_type<2 && hdc_id>0) {
         last_lot_zarar = last_lot_zarar + dc_lot;
         oidi = hedge_id;
         hedge_id = 0;
         hatasayac++;
         
         gb = OrderSelect(oidi,SELECT_BY_TICKET);
         dc_id = OrderTicket();
         dc_type = OrderType();
         dc_lot = OrderLots();
         dc_open = OrderOpenPrice();
         dc_sl = OrderStopLoss();
         dc_tp = OrderStopLoss();
         dc_close = OrderStopLoss();
         dc_closetime = OrderCloseTime();          
         
         
         
      }

   if(oidi!=0) {

      if(OrderType() == 0) {
         last_zarar = (OrderClosePrice()-OrderOpenPrice())/(Point*point);
      } else if(OrderType() == 1) {
         last_zarar = (OrderOpenPrice()-OrderClosePrice())/(Point*point);
      }


      if(dc_closetime>0 && hedge == 0) {
         oidi = 0;
      } else if(hedge == 1) {
      
         if(hedge_id<1) {
         
            double h_lot = 0;
            
            if(lot_model == 0) {
               h_lot = dc_lot * lot_kati;
            } else if(lot_model == 1) {
               h_lot = dc_lot + lot_kati;
            } else if(lot_model == 2) {
               if(last_lot_zarar == 0) {
                  h_lot = dc_lot * lot_kati;
               } else {
                  h_lot = last_lot_zarar * lot_kati;               
               }
            } else if(lot_model == 3) {
               if(last_lot_zarar == 0) {
                  h_lot = dc_lot + lot_kati;
               } else {
                  h_lot = last_lot_zarar + lot_kati;               
               }
            }
         
            if(dc_type == 0) {
               hedge_id = OrderSend(Symbol(),OP_SELLSTOP,h_lot,dc_sl,0,dc_sl+sl*10*Point,dc_sl-tp*10*Point,"",magic,0,clrRed);
                hatasayac++;
            } else if(dc_type == 1) {
               hedge_id = OrderSend(Symbol(),OP_BUYSTOP,h_lot,dc_sl,0,dc_sl-sl*10*Point,dc_sl+tp*10*Point,"",magic,0,clrBlue);
                hatasayac++;
            }
         
         }
         
         
         if(dc_closetime>0 && last_zarar>0) {
            oidi = 0;
            hedge_id = OrderDelete(hedge_id);
            hedge_id = 0;
            last_lot_zarar = 0;
         
         }
      
      }
   
   }

   
   if( TimeHour(TimeCurrent())>=calisma_basla &&  TimeHour(TimeCurrent())<calisma_bitis )   {


      if(kac_hata_sonra == 0) {

      if(oidi == 0) {
   
         if(eskitrend != trend && trend == 1 && eskitrend!=0 && (ana_trend == 0 || ana_trend == 1)) {
            open_order(OP_BUY,clot);
            hatasayac = 0;
         } else if(eskitrend != trend && trend == -1 && eskitrend!=0 && (ana_trend == 0 || ana_trend == -1)) {
            open_order(OP_SELL,clot);
            hatasayac = 0;
         }
   
      }
      
      } else if(kac_hata_sonra>0 && oidi == 0) {
      
         
         if(tarama_price == 0) {
      
         if(eskitrend != trend && trend == 1 && eskitrend!=0 && (ana_trend == 0 || ana_trend == 1)) {
            tarama_price = Ask;
            tarama_yon = 1;
         } else if(eskitrend != trend && trend == -1 && eskitrend!=0 && (ana_trend == 0 || ana_trend == -1)) {
            tarama_price = Bid;
            tarama_yon = -1;
         }      
         
         } else if(tarama_price>0) {
         
               double tarama_pips = 0;
               
               if(tarama_yon == 1) {
                  
                  tarama_pips = (Bid-tarama_price)/(Point*point);
                  
                  if(tarama_pips>=tp) {
                     tarama_price = 0;
                     tarama_yon = 0;
                     kac_hata = 0;
                  } else if(tarama_pips<=(sl*-1)) {
                     tarama_price = Bid;
                     tarama_yon = -1;
                     kac_hata++;
                     
                     if(kac_hata == kac_hata_sonra) {
                        tarama_price = 0;
                        tarama_yon = 0;
                        kac_hata = 0;                     
                        open_order(OP_SELL,clot);
                        hatasayac = 0;
                     }
                     
                  }
               
               
               } else if(tarama_yon == -1) {
                  
                  tarama_pips = (tarama_price-Ask)/(Point*point);
                  
                  if(tarama_pips>=tp) {
                     tarama_price = 0;
                     tarama_yon = 0;
                     kac_hata = 0;
                  } else if(tarama_pips<=(sl*-1)) {
                     tarama_price = Ask;
                     tarama_yon = 1;
                     kac_hata++;
                     
                     if(kac_hata == kac_hata_sonra) {
                        tarama_price = 0;
                        tarama_yon = 0;
                        kac_hata = 0;                     
                        open_order(OP_BUY,clot);
                        hatasayac = 0;
                     }
                     
                  }
               
               
               }
                        
         
         
         }
      
      
      
      }
      
   
   }
   
 
   string cmd = "";
   cmd = StringConcatenate(cmd,"\n");
   cmd = StringConcatenate(cmd,"\n","Tarih2 : ",TimeToStr(TimeCurrent(),TIME_DATE|TIME_MINUTES|TIME_SECONDS)," ",GetTickCount());
   cmd = StringConcatenate(cmd,"\n","Ana Trend : ",ana_trend);
   cmd = StringConcatenate(cmd,"\n","Bid : ",Bid," Ask : ",Ask," Close : ",Close[0]);
   cmd = StringConcatenate(cmd,"\n","magic : ",magic);
   cmd = StringConcatenate(cmd,"\n","Balang Lot : ",clot);
   cmd = StringConcatenate(cmd,"\n","lot : ",sabit_lot);
   cmd = StringConcatenate(cmd,"\n","risk : ",risk);
   cmd = StringConcatenate(cmd,"\n","max_lot : ",max_lot);
   cmd = StringConcatenate(cmd,"\n","hedge : ",hedge);
   cmd = StringConcatenate(cmd,"\n","point : ",point);
   cmd = StringConcatenate(cmd,"\n","lot_model : ",lot_model);
   cmd = StringConcatenate(cmd,"\n","lot_kati : ",lot_kati);
   cmd = StringConcatenate(cmd,"\n","cci : ",cci);
   cmd = StringConcatenate(cmd,"\n","cci_gecikme : ",cci_gecikme);
   cmd = StringConcatenate(cmd,"\n","sl : ",sl);
   cmd = StringConcatenate(cmd,"\n","tp : ",tp);
   cmd = StringConcatenate(cmd,"\n","calisma_basla : ",calisma_basla);
   cmd = StringConcatenate(cmd,"\n","calisma_bitis : ",calisma_bitis);
   cmd = StringConcatenate(cmd,"\n","kac_hata_sonra : ",kac_hata_sonra);
   
   cmd = StringConcatenate(cmd,"\n");
   cmd = StringConcatenate(cmd,"\n","trend : ",strend);
   cmd = StringConcatenate(cmd,"\n","icci : ",icci," Bar Tarih : ",iTime(Symbol(),Period(),cci_gecikme));
   cmd = StringConcatenate(cmd,"\n","last_emir : ",oidi, " type:",dc_type, " close:",dc_closetime);
   cmd = StringConcatenate(cmd,"\n","hedge : ",hedge_id, " type:",hdc_type, " close:",hdc_closetime);
   cmd = StringConcatenate(cmd,"\n","total_zarar : ",DoubleToStr(last_zarar,2));
   cmd = StringConcatenate(cmd,"\n","last_lot_zarar : ",DoubleToStr(last_lot_zarar,2));
   cmd = StringConcatenate(cmd,"\n");
   cmd = StringConcatenate(cmd,"\n","tarama_price : ",DoubleToStr(tarama_price,Digits));
   cmd = StringConcatenate(cmd,"\n","tarama_yon : ",DoubleToStr(tarama_yon,0));
   cmd = StringConcatenate(cmd,"\n","kac_hata : ",kac_hata);
   cmd = StringConcatenate(cmd,"\n\n","hatasayac : ",hatasayac);
   
   Comment(cmd);
   
   
   
   
   eskitrend = trend;



   Sleep(interval);

   }

   
  }
//+------------------------------------------------------------------+

int oidi = 0;

void open_order(int yon, double lotu ) {

   double esl, etp;
   
   if(yon == OP_BUY) {
      esl = (sl>0 ? Ask-sl*point*Point : 0 );
      etp = (tp>0 ? Ask+tp*point*Point : 0 );
      oidi = OrderSend(Symbol(),yon,lotu,Ask,0,esl,etp,"",magic,0,clrBlue);
   } else if(yon == OP_SELL) {
      esl = (sl>0 ? Bid+sl*point*Point : 0 );
      etp = (tp>0 ? Bid-tp*point*Point : 0 );
      oidi = OrderSend(Symbol(),yon,lotu,Bid,0,esl,etp,"",magic,0,clrRed);
   }
}


int makeMagicNumber(string key) {
   int i, k;
   int h = 0;

   if (IsTesting()) {
      key = "_" + key;
   }

   for (i = 0; i < StringLen(key); i++) {
      k = StringGetChar(key, i);
      h = h + k;
      h = bitRotate(h, 5);
   }

   for (i = 0; i < StringLen(key); i++) {
      k = StringGetChar(key, i);
      h = h + k;
      h = bitRotate(h, k & 0x0000000F);
   }

   for (i = StringLen(key); i > 0; i--) {
      k = StringGetChar(key, i - 1);
      h = h + k;
      h = bitRotate(h, h & 0x0000000F);
   }

   return(h & 0x7fffffff);
}

double MARGIN,LOTSTEP,MINLOT,MAXLOT;

//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+


int OnInit()
  {
//---

         EventSetTimer(1);

        magic = makeMagicNumber("rk"+Symbol()+""+IntegerToString(Period()));
        // magic = 134544;

        MARGIN=MarketInfo(Symbol(),MODE_MARGINREQUIRED); if(MARGIN==0){MARGIN=1000; Print("MARGINREQUIRED error");}
        LOTSTEP=MarketInfo(Symbol(),MODE_LOTSTEP); if(LOTSTEP==0){LOTSTEP=0.1; Print("LOTSTEP error");}
        MINLOT=MarketInfo(Symbol(),MODE_MINLOT); if(MINLOT==0){MINLOT=0.1; Print("MINLOT error");}
        MAXLOT=MarketInfo(Symbol(),MODE_MAXLOT); if(MAXLOT==0){MAXLOT=1000; Print("MAXLOT error");}      
        GetLotSize();          
   
//---
   return(INIT_SUCCEEDED);
  }


int bitRotate(int value, int count) {
   int tmp, mask;
   mask = (0x00000001 << count) - 1;
   tmp = value & mask;
   value = value >> count;
   value = value | (tmp << (32 - count));
   return(value);
}

void hepsinikapa() {

  for(int i=OrdersTotal()-1; i>=0; i--)
  {
      int sonuc = OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      if(OrderSymbol()!=Symbol() || OrderMagicNumber()!=magic) continue;
      
      if(OrderType()>1) {
          sonuc = OrderDelete(OrderTicket());
      } else {
      
        if(OrderType()==0) sonuc = OrderClose(OrderTicket(),OrderLots(),Bid,0,CLR_NONE);
        else               sonuc = OrderClose(OrderTicket(),OrderLots(),Ask,0,CLR_NONE);
      }
  }  

}



double Lots,dLot;
datetime last_order2;


void GetLotSize(){
        double eq,ll,kol; double koli;
        
        if(sabit_lot>0) {
         Lots=sabit_lot;
         return;
        } else {
                eq=NormalizeDouble((NormalizeDouble(AccountEquity()/MARGIN,2) * risk)/100,2);
                ll=eq; koli=ll/LOTSTEP; kol=koli*LOTSTEP;
                dLot=kol;
                if(dLot<MINLOT) dLot=MINLOT;
                if(dLot>MAXLOT) dLot=MAXLOT;
                Lots=dLot;
        }
        if(Lots>max_lot) Lots=max_lot;

}


input double trail = 0;

void trailing() {

   int chk;
   
   if(trail == 0) return;

   for(int iw = OrdersTotal()-1;iw>=0;iw--) {
      
      int os = OrderSelect(iw,SELECT_BY_POS,MODE_TRADES);
      
      if(OrderMagicNumber() != magic) continue;
      
      if(OrderType() == 0) {
      
         if( (OrderStopLoss()<OrderOpenPrice() || OrderStopLoss() == 0) && Bid>OrderOpenPrice()+trail*2*10*Point  ) {
            chk = OrderModify(OrderTicket(),OrderOpenPrice(),Bid-trail*10*Point,OrderTakeProfit(),0);
            // Print(StringConcatenate(Symbol()," BUY Spread:",MarketInfo(Symbol(),MODE_SPREAD)," Error : ", GetLastError(), " ", ErrorDescription(GetLastError())," order:",OrderTicket()," fiyat:",OrderOpenPrice()," Ask:",Ask," Bid:",Bid," sl:",(Ask-trail*10*Point)));
         } else if( (OrderStopLoss()>OrderOpenPrice()) && Bid>OrderStopLoss()+trail*2*10*Point  ) {
            chk = OrderModify(OrderTicket(),OrderOpenPrice(),Bid-trail*10*Point,OrderTakeProfit(),0);
         }
      
      
      
      } else if(OrderType() == 1) {
      
      
         if( (OrderStopLoss()>OrderOpenPrice() || OrderStopLoss() == 0) && Ask<OrderOpenPrice()-trail*2*10*Point  ) {
            chk = OrderModify(OrderTicket(),OrderOpenPrice(),Ask+trail*10*Point,OrderTakeProfit(),0);
         } else if( (OrderStopLoss()<OrderOpenPrice()) && Ask<OrderStopLoss()-trail*2*10*Point  ) {
            chk = OrderModify(OrderTicket(),OrderOpenPrice(),Ask+trail*10*Point,OrderTakeProfit(),0);
         }      
      
      
      }
   
   }

}
