color    LineColor        = Orange;

int start() {
	double      Price_on_Drop = WindowPriceOnDropped();
	datetime    time = WindowTimeOnDropped();
	int         TimeNow;
	int         timeframe = Period();
	string TF.Text = "undefined";

	if(IsConnected()) {TimeNow = TimeCurrent();}
	else {TimeNow = time;}

	double point = 0;
	if (Digits == 3 || Digits == 5) {
		point = Point*10;
	} else {
		point = Point;
	}

	switch(timeframe) {
	case 1      :
		TF.Text = "1 Min";
		LineColor = Black;//change this line for color - this one is for 1 min chart.  the color names can be seen in other indicators
		break;
	case 5      :
		TF.Text = "5 Min";
		LineColor = Black;
		break;
	case 15     :
		TF.Text = "15 Min";
		LineColor = Violet;
		break;
	case 30     :
		TF.Text = "30 Min";
		LineColor = Black;
		break;
	case 60     :
		TF.Text = "1Hr";
		LineColor = Orange;
		break;
	case 240    :
		TF.Text = "4Hr";
		LineColor = Blue;
		break;
	case 1440   :
		TF.Text = "Daily";
		LineColor = Brown;
		break;
	case 10080  :
		TF.Text = "Weekly";
		LineColor = Green;
		break;
	case 43200  :
		TF.Text = "Monthly";
		LineColor = Red;
		break;
	}

	string LevelName = TF.Text + "_level__id:" + Price_on_Drop;
	string LevelNameFill = TF.Text + "_level__id_fill:" + Price_on_Drop;

	ObjectCreate(LevelName, OBJ_TREND, 0, time,Price_on_Drop, time+Period()*60*100,Price_on_Drop);
	ObjectSet(LevelName,OBJPROP_RAY,1);//make the lines continue to the right
	ObjectSet(LevelName,OBJPROP_COLOR, LineColor);
	ObjectSet(LevelName,OBJPROP_BACK,1);
	ObjectSet(LevelName,OBJPROP_WIDTH,2);//the width of the line
	ObjectSet(LevelName,OBJPROP_FONTSIZE,14);
	ObjectSetText( LevelName, TF.Text, 0, "", CLR_NONE);

	return(0);
}

