//+------------------------------------------------------------------+
//|                                                             .mq4 |
//|                        Copyright 2013, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright 2013, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_separate_window

#property indicator_buffers 2

#property indicator_color1 DeepSkyBlue
#property indicator_color2 PaleVioletRed

extern int Count_Bars=1000;

double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double Formula[];

int init()
  {

   IndicatorBuffers(4);
   SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,3);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexStyle(1,DRAW_LINE,STYLE_SOLID,3);
   SetIndexBuffer(1,ExtMapBuffer3);
   SetIndexStyle(2,DRAW_NONE,STYLE_SOLID,3,Yellow);
   SetIndexBuffer(2,ExtMapBuffer2);
   SetIndexBuffer(3,Formula);

   string short_name="CoDe";
   IndicatorShortName(short_name);

   return(0);
  }

int deinit()
  {

   return(0);
  }

int start()
  {
   int pos=0;
   if (Count_Bars>Bars) {pos=Bars;}else{pos=Count_Bars;}
   int temp=pos;
   while(pos>=0)
     {

      double Stoch=iStochastic(NULL,0,8,3,3,MODE_EMA,1,0,pos);
      double RSI=iRSI(NULL,0,8,PRICE_TYPICAL,pos);
      double moment=(iMomentum(NULL,0,8,PRICE_TYPICAL,pos));

      if (moment!=0)
         ExtMapBuffer2[pos]=Stoch*(RSI)/moment;

      pos--;
     }
     while(temp >=0) 
     {
      ExtMapBuffer1[temp]=EMPTY_VALUE;
      ExtMapBuffer3[temp]=EMPTY_VALUE;
      Formula[temp]=iMAOnArray(ExtMapBuffer2,0,2,0,MODE_SMA,temp);
        if (Formula[temp]>Formula[temp+1])
        {
         ExtMapBuffer1[temp]=Formula[temp];
         if (ExtMapBuffer1[temp+1]==EMPTY_VALUE) ExtMapBuffer1[temp+1]=Formula[temp+1];
         }
         else
         {
         ExtMapBuffer3[temp]=Formula[temp];
         if (ExtMapBuffer3[temp+1]==EMPTY_VALUE) ExtMapBuffer3[temp+1]=Formula[temp+1];
        }
     temp--; 
     }

   return(0);
  }


