#property indicator_separate_window
#property indicator_minimum -100.0
#property indicator_maximum 100.0
#property indicator_levelcolor DimGray
#property indicator_levelstyle 1
#property indicator_buffers 8
#property indicator_color1 Black
#property indicator_color2 Black
#property indicator_color3 Black
#property indicator_color4 Black
#property indicator_color5 CadetBlue
#property indicator_color6 IndianRed
#property indicator_color7 DodgerBlue
#property indicator_color8 Tomato
#property indicator_width1 1
#property indicator_level1 60.0
#property indicator_width2 1
#property indicator_level2 50.0
#property indicator_level3 -50.0
#property indicator_level4 -60.0

extern int WavePeriod = 3;
extern int AvgPeriod = 7;
extern bool SoundAlert = TRUE;
extern bool EmailAlert = FALSE;
extern int Envelope_Period = 100;
extern double Envelope_Deviation = 0.1;
double g_ibuf_92[];
double g_ibuf_96[];
double g_ibuf_100[];
double g_ibuf_104[];
double g_ibuf_108[];
double g_ibuf_112[];
double g_ibuf_116[];
double g_ibuf_120[];
int env_buf[];
int gi_124 = -50;
int gi_128 = 53;
int gi_132;
double env_hi_0, env_lo_0;

int init() {
   IndicatorShortName("Super Trend Signal");
   SetIndexBuffer(0, g_ibuf_100);
   SetIndexLabel(0, "ESA");
   SetIndexStyle(0, DRAW_NONE);
   SetIndexDrawBegin(0, 0);
   SetIndexBuffer(1, g_ibuf_112);
   SetIndexLabel(1, "DD Values");
   SetIndexStyle(1, DRAW_NONE);
   SetIndexDrawBegin(1, 0);
   SetIndexBuffer(2, g_ibuf_104);
   SetIndexLabel(2, "DD");
   SetIndexStyle(2, DRAW_NONE);
   SetIndexDrawBegin(2, 0);
   SetIndexBuffer(3, g_ibuf_108);
   SetIndexLabel(3, "CI");
   SetIndexStyle(3, DRAW_NONE);
   SetIndexDrawBegin(3, 0);
   SetIndexBuffer(4, g_ibuf_92);
   SetIndexLabel(4, "Bull 181");
   SetIndexStyle(4, DRAW_LINE, STYLE_SOLID, 1, CadetBlue);
   SetIndexDrawBegin(4, 0);
   SetIndexBuffer(5, g_ibuf_96);
   SetIndexLabel(5, "Bear 181");
   SetIndexStyle(5, DRAW_LINE, STYLE_SOLID, 1, IndianRed);
   SetIndexDrawBegin(5, 0);
   SetIndexBuffer(6, g_ibuf_116);
   SetIndexLabel(6, "Buy Dot 181");
   SetIndexStyle(6, DRAW_ARROW, STYLE_SOLID, 1, DodgerBlue);
   SetIndexArrow(6, 108);
   SetIndexDrawBegin(6, 0);
   SetIndexBuffer(7, g_ibuf_120);
   SetIndexLabel(7, "Sell Dot 181");
   SetIndexStyle(7, DRAW_ARROW, STYLE_SOLID, 1, Tomato);
   SetIndexArrow(7, 108);
   SetIndexDrawBegin(7, 0);
   return (0);
}

int start() {
   double l_ima_on_arr_0;
   //Comment("");
   int li_12 = IndicatorCounted();
   if (li_12 < 0) return (-1);
   if (li_12 > 0) li_12--;
   int l_bars_8 = Bars;
   for (int l_bars_16 = l_bars_8; l_bars_16 > 0; l_bars_16--) {
      g_ibuf_100[l_bars_16] = iMA(NULL, 0, WavePeriod, 0, MODE_EMA, PRICE_TYPICAL, l_bars_16);
      ArraySetAsSeries(g_ibuf_100, TRUE);
   }
   for (l_bars_16 = l_bars_8; l_bars_16 > 0; l_bars_16--) {
      g_ibuf_112[l_bars_16] = MathAbs((iHigh(NULL, 0, l_bars_16) + iClose(NULL, 0, l_bars_16) + iLow(NULL, 0, l_bars_16)) / 3.0 - g_ibuf_100[l_bars_16]);
      ArraySetAsSeries(g_ibuf_112, TRUE);
   }
   for (l_bars_16 = l_bars_8; l_bars_16 > 0; l_bars_16--) {
      l_ima_on_arr_0 = iMAOnArray(g_ibuf_112, 0, WavePeriod, 0, MODE_EMA, l_bars_16);
      g_ibuf_104[l_bars_16] = l_ima_on_arr_0;
      ArraySetAsSeries(g_ibuf_104, TRUE);
   }
   for (l_bars_16 = l_bars_8; l_bars_16 > 0; l_bars_16--) {
      if (g_ibuf_104[l_bars_16] > 0.0) g_ibuf_108[l_bars_16] = ((iHigh(NULL, 0, l_bars_16) + iClose(NULL, 0, l_bars_16) + iLow(NULL, 0, l_bars_16)) / 3.0 - g_ibuf_100[l_bars_16]) / (0.015 * g_ibuf_104[l_bars_16]);
      else g_ibuf_108[l_bars_16] = 0;
      ArraySetAsSeries(g_ibuf_108, TRUE);
   }
   for (l_bars_16 = l_bars_8; l_bars_16 > 0; l_bars_16--) {
      l_ima_on_arr_0 = iMAOnArray(g_ibuf_108, 0, AvgPeriod, 0, MODE_EMA, l_bars_16);
      g_ibuf_92[l_bars_16] = l_ima_on_arr_0;
      ArraySetAsSeries(g_ibuf_92, TRUE);
   }
   for (l_bars_16 = l_bars_8; l_bars_16 > 0; l_bars_16--) {
      l_ima_on_arr_0 = iMAOnArray(g_ibuf_92, 0, 4, 0, MODE_SMA, l_bars_16);
      g_ibuf_96[l_bars_16] = l_ima_on_arr_0;
      ArraySetAsSeries(g_ibuf_96, TRUE);
   }
   for (l_bars_16 = l_bars_8; l_bars_16 > 0; l_bars_16--) {
      if (g_ibuf_92[l_bars_16] >= g_ibuf_96[l_bars_16] && g_ibuf_92[l_bars_16 + 1] <= g_ibuf_96[l_bars_16 + 1] && g_ibuf_92[l_bars_16] < gi_124)
      {
         env_lo_0 = iEnvelopes(NULL, 0, Envelope_Period,MODE_SMA,0,PRICE_CLOSE,Envelope_Deviation,MODE_LOWER,l_bars_16);
      
         if (Low[l_bars_16]<env_lo_0)
         {
            g_ibuf_116[l_bars_16] = g_ibuf_92[l_bars_16];
            if (l_bars_16 == 1) SendAlert("buy");
         }
      }
      else g_ibuf_116[l_bars_16] = -1000;
      if (g_ibuf_92[l_bars_16] <= g_ibuf_96[l_bars_16] && g_ibuf_92[l_bars_16 + 1] >= g_ibuf_96[l_bars_16 + 1] && g_ibuf_92[l_bars_16] > gi_128)
      {   
         env_hi_0 = iEnvelopes(NULL, 0, Envelope_Period,MODE_SMA,0,PRICE_CLOSE,Envelope_Deviation,MODE_UPPER,l_bars_16); 
         if (High[l_bars_16]>env_hi_0)
         {
         g_ibuf_120[l_bars_16] = g_ibuf_96[l_bars_16];
         if (l_bars_16 == 1) SendAlert("sell");
         }
      }
      else g_ibuf_120[l_bars_16] = -1000;
   }
   return (0);
}

void SendAlert(string as_0) {
   if (Time[1] != gi_132) {
      if (SoundAlert) {
         if (as_0 == "buy") Alert(Symbol() + " => TF: " + Period() + "M => " + TimeToStr(TimeCurrent()) + " buy");
         if (as_0 == "sell") Alert(Symbol() + " => TF: " + Period() + "M => " + TimeToStr(TimeCurrent()) + " sell");
      }
      if (EmailAlert) {
         if (as_0 == "buy") SendMail("TrendWave Alert", Symbol() + " => TF: " + Period() + "M => " + TimeToStr(TimeCurrent()) + " buy");
         if (as_0 == "sell") SendMail("TrendWave Alert", Symbol() + " => TF: " + Period() + "M => " + TimeToStr(TimeCurrent()) + " sell");
      }
      gi_132 = Time[1];
   }
}