//+------------------------------------------------------------------+
//|                                                     PSAR_MTF.mq4 |
//|                                                        Taiyakixz |
//|              http://www.forexfactory.com/showthread.php?t=249376 |
//+------------------------------------------------------------------+
#property copyright "Taiyakixz"
#property link      "http://www.forexfactory.com/showthread.php?t=249376"

#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 Yellow

extern int       TimeFrame = 240;
extern double    Step=0.02;
extern double    Maximum=0.2;

double PSARBuffer[];


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_ARROW);
   SetIndexArrow(0,159);
   SetIndexBuffer(0,PSARBuffer);

   if( ( TimeFrame != PERIOD_M1 && TimeFrame != PERIOD_M5 && TimeFrame != PERIOD_M15 && TimeFrame != PERIOD_M30
    && TimeFrame != PERIOD_H1 && TimeFrame != PERIOD_H4
    && TimeFrame != PERIOD_D1 && TimeFrame != PERIOD_W1 && TimeFrame != PERIOD_MN1 )
    || TimeFrame < Period() ) TimeFrame = Period();

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int psarBarShift;
   int minLimit;
   double psarValue;
   int    counted_bars=IndicatorCounted();
//----
   if(counted_bars < 0) return(-1);
   if(counted_bars > 0) counted_bars--;
   int limit = Bars - counted_bars;
   
   minLimit = iBarShift(NULL, 0, iTime(NULL, TimeFrame, 0) );
   if( limit < minLimit ) limit = minLimit;
   
   for(int i=limit; i>=0; i--)
   {
     psarBarShift = iBarShift( NULL, TimeFrame , Time[i] );
     psarValue = iSAR( NULL, TimeFrame, Step, Maximum, psarBarShift );
     PSARBuffer[i] = psarValue;
   }
//----
   return(0);
  }
//+------------------------------------------------------------------+