//+------------------------------------------------------------------+
//|                                        Brooky_Trend_Strength.mq4 |
//|                                          Copyright  2010,Brooky |
//|                               http://forex-indicators.weebly.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010,Brooky"
#property link      "http://forex-indicators.weebly.com"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 Chartreuse
#property indicator_color2 Crimson
#property indicator_width1 1
#property indicator_width2 1
#property indicator_level1 0


//---- input parameters
extern int       Atr_Std_Period=14;
//---- buffers
double atr_buff[];
double sig_buff[];
double atr_array[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   IndicatorBuffers(3);
   SetIndexBuffer(0,atr_buff);SetIndexStyle(0,DRAW_LINE);
   
   SetIndexBuffer(1,sig_buff);SetIndexStyle(1,DRAW_LINE);
   
   
   SetIndexBuffer(2,atr_array);
   
//---- name for DataWindow and indicator subwindow label
   IndicatorShortName("forex-indicators.weebly.com Trend Strength "
                       +"Period ("
                        +Atr_Std_Period+")"
                        );   
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
  int start()
    {
     int limit;
     int counted_bars=IndicatorCounted();
  //---- check for possible errors
     if(counted_bars<0) return(-1);
  //---- the last counted bar will be recounted
     if(counted_bars>0) counted_bars--;
     limit=Bars-counted_bars;
  //---- main loop
     for(int i=0; i<limit; i++)
       {
        atr_array[i] = iStdDev(NULL,0,Atr_Std_Period,0,MODE_EMA,PRICE_CLOSE,i)
                        -iATR(NULL,0,Atr_Std_Period,i);

         atr_buff[i]=atr_array[i];
         
        }
     for(i=0; i<limit; i++)
       {
        sig_buff[i] = iMAOnArray(atr_array,0,5,0,MODE_LWMA,i);

       }
  //---- done
     return(0);
    }
//+------------------------------------------------------------------+