
#property copyright "Raouf Riad"
#property link      ""

#property indicator_separate_window
#property indicator_minimum 0.0
#property indicator_maximum 1.0
#property indicator_buffers 3
#property indicator_color1 Yellow
#property indicator_color2 Blue
#property indicator_color3 Red

double G_ibuf_76[];
double G_ibuf_80[];
double G_ibuf_84[];
double G_ibuf_88[];

int init() {
   IndicatorShortName("STRONG SYSTEM C Raouf Riad 2009-2010 ");
   IndicatorBuffers(4);
   SetIndexBuffer(0, G_ibuf_76);
   SetIndexBuffer(1, G_ibuf_80);
   SetIndexBuffer(2, G_ibuf_84);
   SetIndexBuffer(3, G_ibuf_88);
   SetIndexStyle(0, DRAW_HISTOGRAM);
   SetIndexStyle(1, DRAW_HISTOGRAM);
   SetIndexStyle(2, DRAW_HISTOGRAM);
   int Li_0 = MathFloor(MathSqrt(34)) + 34.0;
   for (int Li_4 = 0; Li_4 < 3; Li_4++) {
      SetIndexDrawBegin(Li_4, Li_0);
      SetIndexLabel(Li_4, "STRONG SYSTEM");
   }
   return (0);
}

int start() {
   int period_0 = MathFloor(17);
   int period_4 = MathFloor(MathSqrt(34));
   int Li_8 = IndicatorCounted();
   if (Li_8 < 0) return (-1);
   if (Li_8 > 0) Li_8--;
   int Li_12 = Bars - Li_8;
   for (int Li_16 = Li_12; Li_16 >= 0; Li_16--) G_ibuf_88[Li_16] = 2.0 * iMA(NULL, 0, period_0, 0, MODE_SMMA, PRICE_CLOSE, Li_16) - iMA(NULL, 0, 34, 0, MODE_SMMA, PRICE_CLOSE, Li_16);
   for (Li_16 = Li_12; Li_16 >= 0; Li_16--) {
      G_ibuf_76[Li_16] = iMAOnArray(G_ibuf_88, 0, period_4, 0, MODE_SMMA, Li_16);
      G_ibuf_80[Li_16] = EMPTY_VALUE;
      G_ibuf_84[Li_16] = EMPTY_VALUE;
      if (G_ibuf_76[Li_16] > G_ibuf_76[Li_16 + 1]) G_ibuf_80[Li_16] = 1;
      if (G_ibuf_76[Li_16] < G_ibuf_76[Li_16 + 1]) G_ibuf_84[Li_16] = 1;
   }
   return (0);
}