//+------------------------------------------------------------------+
//|                                                      Ma Zone.mq4 |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright ""
#property link      ""

#property indicator_chart_window

#property indicator_buffers 8

#property indicator_color1 EMPTY
#property indicator_color2 EMPTY
#property indicator_color3 DimGray
#property indicator_color4 DeepSkyBlue
#property indicator_color5 Green
#property indicator_color6 DimGray
#property indicator_color7 PaleVioletRed
#property indicator_color8 Red

#property indicator_width3 2
#property indicator_style4 STYLE_DASH
#property indicator_style5 STYLE_DASHDOTDOT
#property indicator_width6 2
#property indicator_style7 STYLE_DASH
#property indicator_style8 STYLE_DASHDOTDOT


extern bool Alerts      = false;
extern int  RiskModel   = 1;
extern int  MA1         = 55;
extern int  MA2         = 89;
extern int  LEVEL1      = 0;
extern int  LEVEL2      = 55;
extern int  LEVEL3      = 89;
extern int  LEVEL4      = 144;
extern int  LEVEL5      = 233;
extern int  LEVEL6      = 377;

double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];
double ExtMapBuffer5[];
double ExtMapBuffer6[];
double ExtMapBuffer7[];
double ExtMapBuffer8[];

int init()
  {

   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(2,ExtMapBuffer3);
   SetIndexStyle(3,DRAW_LINE);
   SetIndexBuffer(3,ExtMapBuffer4);
   SetIndexStyle(4,DRAW_LINE);
   SetIndexBuffer(4,ExtMapBuffer5);
   SetIndexStyle(5,DRAW_LINE);
   SetIndexBuffer(5,ExtMapBuffer6);
   SetIndexStyle(6,DRAW_LINE);
   SetIndexBuffer(6,ExtMapBuffer7);
   SetIndexStyle(7,DRAW_LINE);
   SetIndexBuffer(7,ExtMapBuffer8);

   return(0);
  }

int deinit()
  {

   return(0);
  }

int start()
  {
   int limit;
   int    counted_bars=IndicatorCounted();

   if(counted_bars<0) return(-1);

   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
   if(counted_bars==0) limit--;

   for(int i=0; i<limit; i++)
     {

      ExtMapBuffer1[i]=iMA(NULL,0,MA1,0,MODE_EMA,PRICE_CLOSE,i);
      ExtMapBuffer2[i]=iMA(NULL,0,MA2,0,MODE_EMA,PRICE_CLOSE,i);

      if(RiskModel==1)
        {
         ExtMapBuffer3[i]=ExtMapBuffer2[i]+LEVEL1*Point;
         ExtMapBuffer4[i]=ExtMapBuffer2[i]+LEVEL2*Point;
         ExtMapBuffer5[i]=ExtMapBuffer2[i]+LEVEL3*Point;
         ExtMapBuffer6[i]=ExtMapBuffer2[i]-LEVEL1*Point;
         ExtMapBuffer7[i]=ExtMapBuffer2[i]-LEVEL2*Point;
         ExtMapBuffer8[i]=ExtMapBuffer2[i]-LEVEL3*Point;
        }

      if(RiskModel==2)
        {
         ExtMapBuffer3[i]=ExtMapBuffer2[i]+LEVEL2*Point;
         ExtMapBuffer4[i]=ExtMapBuffer2[i]+LEVEL3*Point;
         ExtMapBuffer5[i]=ExtMapBuffer2[i]+LEVEL4*Point;
         ExtMapBuffer6[i]=ExtMapBuffer2[i]-LEVEL2*Point;
         ExtMapBuffer7[i]=ExtMapBuffer2[i]-LEVEL3*Point;
         ExtMapBuffer8[i]=ExtMapBuffer2[i]-LEVEL4*Point;
        }

      if(RiskModel==3)
        {
         ExtMapBuffer3[i]=ExtMapBuffer2[i]+LEVEL3*Point;
         ExtMapBuffer4[i]=ExtMapBuffer2[i]+LEVEL4*Point;
         ExtMapBuffer5[i]=ExtMapBuffer2[i]+LEVEL5*Point;
         ExtMapBuffer6[i]=ExtMapBuffer2[i]-LEVEL3*Point;
         ExtMapBuffer7[i]=ExtMapBuffer2[i]-LEVEL4*Point;
         ExtMapBuffer8[i]=ExtMapBuffer2[i]-LEVEL5*Point;
        }

      if(RiskModel==4)
        {
         ExtMapBuffer3[i]=ExtMapBuffer2[i]+LEVEL4*Point;
         ExtMapBuffer4[i]=ExtMapBuffer2[i]+LEVEL5*Point;
         ExtMapBuffer5[i]=ExtMapBuffer2[i]+LEVEL6*Point;
         ExtMapBuffer6[i]=ExtMapBuffer2[i]-LEVEL4*Point;
         ExtMapBuffer7[i]=ExtMapBuffer2[i]-LEVEL5*Point;
         ExtMapBuffer8[i]=ExtMapBuffer2[i]-LEVEL6*Point;
        }
      Comment("");
     }

   if(Alerts)
     {
      if(Close[i]==ExtMapBuffer1[i] || Close[i]==ExtMapBuffer2[i])
        {
         PlaySound("alert.wav");
         Alert("Fib Or Channel Signal Triggered For "+Symbol()+" On The "+Period()+" Minute Chart");
        }
      if(Close[i]==ExtMapBuffer3[i] || Close[i]==ExtMapBuffer4[i] || Close[i]==ExtMapBuffer5[i])
        {
         PlaySound("alert.wav");
         Alert("Fib Or Channel Signal Triggered For "+Symbol()+" On The "+Period()+" Minute Chart");
        }
      if(Close[i]==ExtMapBuffer6[i] || Close[i]==ExtMapBuffer7[i] || Close[i]==ExtMapBuffer8[i])
        {
         PlaySound("alert.wav");
         Alert("Fib Or Channel Signal Triggered For "+Symbol()+" On The "+Period()+" Minute Chart");
        }
     }

   return(0);
  }