//+------------------------------------------------------------------+
//|                                                 peatsfx-HPFZ.mq4 |
//|                                    Copyright 2013, A.E. Ivan, ST |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright 2013, A.E. Ivan, ST"
#property link      "bengkel.ea.forex@gmail.com"

#property indicator_chart_window

extern string Indicator_Name = "peatsfx-HPFZ";
extern string eMail = "bengkel.ea.forex@gmail.com";

int init()
  {

   
   return(0);
  }

int deinit()
  {
//----
   ObjectDelete("BP-Text");
   ObjectDelete("BP");
   
   ObjectDelete("Zone-3");
   ObjectDelete("Zone-3 Value");
   
   ObjectDelete("Zone-2");
   ObjectDelete("Zone-2 Value");  
   
   ObjectDelete("Zone-4");
   ObjectDelete("Zone-4 Value");  
   
   ObjectDelete("Zone-5");
   ObjectDelete("Zone-5 Value");  
//----
   return(0);
  }

int start()
  {

   
   double Daily_Buka = iOpen(Symbol(),PERIOD_D1,0);
   double Daily_High = iHigh(Symbol(),PERIOD_D1,1);
   double Daily_Low = iLow(Symbol(),PERIOD_D1,1); 
   double Daily_Tutup = iClose(Symbol(),PERIOD_D1,1); 
   double pengali, pengurang, desimal;

      int y=TimeYear(TimeCurrent());
      int d=TimeDay(TimeCurrent());
      int dbsk=TimeDay(TimeCurrent()+86400);
      int m=TimeMonth(TimeCurrent());
      string h= "00:00";
      string l= "12:00";
      string sekarang = StringConcatenate(y ,".", m, ".", d," ",h);
      string besok = StringConcatenate(y ,".", m, ".", dbsk," ",h);

      datetime var1 = StrToTime(sekarang);
      datetime var2 = StrToTime(besok);

      
   if(Symbol()== "USDJPY" || Symbol()== "EURJPY" || Symbol()== "GBPJPY" || Symbol()== "CADJPY" || Symbol()== "NZDJPY" || Symbol()== "AUDJPY" || Symbol()== "CHFJPY")
   {
   
         desimal= 3;
         pengali = 100;
  }
   else
   {
         desimal= 5;
         pengali = 10000;
    }

 
   double Range_Harian = (Daily_High - Daily_Low);
   double fibo_range_A = (0.618 * Range_Harian);
   double fibo_range_B = (1.382 * Range_Harian);
    
   double garis_tengah = (Daily_High + Daily_Low + Daily_Tutup)/3;
   double garistengahtext = ((Daily_High + Daily_Low + Daily_Tutup)/3);
   double line_C = (Range_Harian/2);
   
   double zone_E = garis_tengah + Range_Harian;
   double zone_E1 =garis_tengah + fibo_range_B;

   double zone_D = garis_tengah + line_C ;
   double zone_D1 = garis_tengah + fibo_range_A ;

   double zone_B = garis_tengah - line_C ;
   double zone_B1 = garis_tengah - fibo_range_A ;

   double zone_A = garis_tengah - Range_Harian;
   double zone_A1=garis_tengah - fibo_range_B;

   ObjectDelete("BP-Text");
   ObjectDelete("BP");

   ObjectDelete("Zone-3");
   ObjectDelete("Zone-3 Value");
 
   ObjectDelete("Zone-2");
   ObjectDelete("Zone-2 Value");
   
   ObjectDelete("Zone-4");
   ObjectDelete("Zone-4 Value"); 
   
   ObjectDelete("Zone-5");
   ObjectDelete("Zone-5 Value");       
   
   
             ObjectCreate("BP",OBJ_RECTANGLE,0,0,0,0,0);
             ObjectSet("BP",OBJPROP_TIME1,var1);
             ObjectSet("BP",OBJPROP_TIME2,var2);
             ObjectSet("BP",OBJPROP_PRICE1,garis_tengah);
             ObjectSet("BP",OBJPROP_PRICE2,garis_tengah);
             ObjectSet("BP",OBJPROP_COLOR,White);
             ObjectSet("BP", OBJPROP_BACK, false);
             ObjectSet("BP", OBJPROP_WIDTH, 0);
             ObjectSet("BP", OBJPROP_STYLE, 0);

             
             ObjectCreate("BP-Text", OBJ_TEXT, 0, var2, ObjectGet("BP", OBJPROP_PRICE1) );
             ObjectSetText("BP-Text", "Balance Point (" + DoubleToStr(garistengahtext,desimal)+")", 8, "Arial", White); 
             
             
             
             ObjectCreate("Zone-3",OBJ_RECTANGLE,0,0,0,0,0);
             ObjectSet("Zone-3",OBJPROP_TIME1,var1);
             ObjectSet("Zone-3",OBJPROP_TIME2,var2);
             ObjectSet("Zone-3",OBJPROP_PRICE1,zone_B);
             ObjectSet("Zone-3",OBJPROP_PRICE2,zone_B1);
             ObjectSet("Zone-3",OBJPROP_COLOR,Red);
             ObjectSet("Zone-3", OBJPROP_BACK, true);
             ObjectSet("Zone-3", OBJPROP_WIDTH, 0);
             ObjectSet("Zone-3", OBJPROP_STYLE, 0);

             
             ObjectCreate("Zone-3 Value", OBJ_TEXT, 0, var2, ObjectGet("Zone-3", OBJPROP_PRICE1) );
             ObjectSetText("Zone-3 Value", "Support Band - 1", 8, "Arial", Goldenrod); 
             
             
             ObjectCreate("Zone-2",OBJ_RECTANGLE,0,0,0,0,0);
             ObjectSet("Zone-2",OBJPROP_TIME1,var1);
             ObjectSet("Zone-2",OBJPROP_TIME2,var2);
             ObjectSet("Zone-2",OBJPROP_PRICE1,zone_A);
             ObjectSet("Zone-2",OBJPROP_PRICE2,zone_A1);
             ObjectSet("Zone-2",OBJPROP_COLOR,Maroon);
             ObjectSet("Zone-2", OBJPROP_BACK, true);
             ObjectSet("Zone-2", OBJPROP_WIDTH, 0);
             ObjectSet("Zone-2", OBJPROP_STYLE, 0);

             
             ObjectCreate("Zone-2 Value", OBJ_TEXT, 0, var2, ObjectGet("Zone-2", OBJPROP_PRICE1) );
             ObjectSetText("Zone-2 Value", "Support Band - 2", 8, "Arial", Goldenrod); 
                                  
  
             ObjectCreate("Zone-4",OBJ_RECTANGLE,0,0,0,0,0);
             ObjectSet("Zone-4",OBJPROP_TIME1,var1);
             ObjectSet("Zone-4",OBJPROP_TIME2,var2);
             ObjectSet("Zone-4",OBJPROP_PRICE1,zone_D);
             ObjectSet("Zone-4",OBJPROP_PRICE2,zone_D1);
             ObjectSet("Zone-4",OBJPROP_COLOR,Navy);
             ObjectSet("Zone-4", OBJPROP_BACK, true);
             ObjectSet("Zone-4", OBJPROP_WIDTH, 0);
             ObjectSet("Zone-4", OBJPROP_STYLE, 0);

             
             ObjectCreate("Zone-4 Value", OBJ_TEXT, 0, var2, ObjectGet("Zone-4", OBJPROP_PRICE2) );
             ObjectSetText("Zone-4 Value", "Resistance Band - 1", 8, "Arial", Gold);  
  
  
             ObjectCreate("Zone-5",OBJ_RECTANGLE,0,0,0,0,0);
             ObjectSet("Zone-5",OBJPROP_TIME1,var1);
             ObjectSet("Zone-5",OBJPROP_TIME2,var2);
             ObjectSet("Zone-5",OBJPROP_PRICE1,zone_E);
             ObjectSet("Zone-5",OBJPROP_PRICE2,zone_E1);
             ObjectSet("Zone-5",OBJPROP_COLOR,MidnightBlue);
             ObjectSet("Zone-5", OBJPROP_BACK, true);
             ObjectSet("Zone-5", OBJPROP_WIDTH, 0);
             ObjectSet("Zone-5", OBJPROP_STYLE, 0);

             
             ObjectCreate("Zone-5 Value", OBJ_TEXT, 0, var2, ObjectGet("Zone-5", OBJPROP_PRICE2) );
             ObjectSetText("Zone-5 Value", "Resistance Band - 2", 8, "Arial", Gold);  
 
  
  }
//+------------------------------------------------------------------+