//+------------------------------------------------------------------+
//|                                                        PLdot.mq4 |
//|                                      Copyright  2006, Eli hayun |
//|                                          http://www.elihayun.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, Eli hayun"
#property link      "http://www.elihayun.com"

#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 Red
//---- buffers
double ExtMapBuffer1[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_ARROW);
   SetIndexArrow(0,164);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexShift(0,1);
   SetIndexEmptyValue(0,0.0);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();
   
      if(counted_bars<0) return(-1);
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;

   int pos=Bars-counted_bars;
   
   while (pos>=0) 
   {
       ExtMapBuffer1[pos] = iMA(NULL,0,3,0,0,PRICE_TYPICAL,pos); 
       //(
       //  ((High[pos+0] + Low[pos+0]+Close[pos+0]) / 3) + 
       //  ((High[pos+1] + Low[pos+1]+Close[pos+1]) / 3) + 
       //  ((High[pos+2] + Low[pos+2]+Close[pos+2]) / 3) 
       //) / 3;
     pos--;
   }
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+