//+------------------------------------------------------------------+
//|                                                    Snake_mod.mq4 |
//|                                              modified by marsya7 |
//|                                     http://www.kgforexworld.Com/ |
//+------------------------------------------------------------------+
#property copyright "modified by marsya7"
#property link      " http://www.kgforexworld.Com/"
//----
#property indicator_chart_window
#property indicator_buffers 5
#property indicator_color1 Yellow
#property indicator_color2 Lime
#property indicator_color3 Lime
#property indicator_color4 Red
#property indicator_color5 Red
#property indicator_width1 1
#property indicator_width2 1
#property indicator_width3 1
#property indicator_width4 1
#property indicator_width5 1
//----
extern int Snake_HalfCycle=60; // Snake_HalfCycle = 4...10 or other
//----
double Snake_Buffer[],
       Snake_Bufferua[],
       Snake_Bufferub[],
       Snake_Bufferda[],
       Snake_Bufferdb[];
double Snake_Sum, Snake_Weight, Snake_Sum_Minus, Snake_Sum_Plus;
int Snake_FullCycle;
//----
int init()
{
int    draw_begin;
   Snake_FullCycle=Snake_HalfCycle*2+1;
   draw_begin=Snake_FullCycle+1;
   SetIndexDrawBegin(0,draw_begin);
   SetIndexBuffer(0,Snake_Buffer);
   SetIndexStyle(0,DRAW_LINE);
//----
   SetIndexDrawBegin(1,draw_begin);
   SetIndexBuffer(1,Snake_Bufferua);
   SetIndexStyle(1,DRAW_LINE);
//----
   SetIndexDrawBegin(2,draw_begin);
   SetIndexBuffer(2,Snake_Bufferub);
   SetIndexStyle(2,DRAW_LINE);
//----
   SetIndexDrawBegin(3,draw_begin);
   SetIndexBuffer(3,Snake_Bufferda);
   SetIndexStyle(3,DRAW_LINE);
//----
   SetIndexDrawBegin(4,draw_begin);
   SetIndexBuffer(4,Snake_Bufferdb);
   SetIndexStyle(4,DRAW_LINE);
   return(0);
}
//----
int start()
{
int FirstPos, ExtCountedBars=0;
   if(Bars<=150) return(0);
   if(Snake_HalfCycle<3) Snake_HalfCycle=3;
   ExtCountedBars=IndicatorCounted();
   if (ExtCountedBars<0) return(-1);
   if (ExtCountedBars>0) ExtCountedBars--;
   FirstPos=Bars-ExtCountedBars-1;
   if(FirstPos>Bars-Snake_HalfCycle-1) FirstPos=Bars-Snake_HalfCycle-1;
   Snake(FirstPos);
//----
   if (Snake_Buffer[FirstPos] > Snake_Buffer[FirstPos+1]) CleanPoint(FirstPos,Snake_Bufferua,Snake_Bufferub);
   if (Snake_Buffer[FirstPos] < Snake_Buffer[FirstPos+1]) CleanPoint(FirstPos,Snake_Bufferda,Snake_Bufferdb);
   return(0);
}
//----
void Snake(int Pos)
{
int i;
   if(Pos<=Snake_HalfCycle+1) Pos=Snake_HalfCycle+2;
   Snake_Buffer[Pos]=SnakeFirstCalc(Pos);
   Pos--;
      Snake_Bufferua[Pos] = EMPTY_VALUE;
      Snake_Bufferub[Pos] = EMPTY_VALUE;
      Snake_Bufferda[Pos] = EMPTY_VALUE;
      Snake_Bufferdb[Pos] = EMPTY_VALUE;
         if (Snake_Buffer[Pos] > Snake_Buffer[Pos+1]) PlotPoint(Pos,Snake_Bufferua,Snake_Bufferub,Snake_Buffer);
         if (Snake_Buffer[Pos] < Snake_Buffer[Pos+1]) PlotPoint(Pos,Snake_Bufferda,Snake_Bufferdb,Snake_Buffer);
   while(Pos>=Snake_HalfCycle)
   {
      Snake_Buffer[Pos]=SnakeNextCalc(Pos);
      Pos--;
       Snake_Bufferua[Pos] = EMPTY_VALUE;
       Snake_Bufferub[Pos] = EMPTY_VALUE;
       Snake_Bufferda[Pos] = EMPTY_VALUE;
       Snake_Bufferdb[Pos] = EMPTY_VALUE;
         if (Snake_Buffer[Pos] > Snake_Buffer[Pos+1]) PlotPoint(Pos,Snake_Bufferua,Snake_Bufferub,Snake_Buffer);
         if (Snake_Buffer[Pos] < Snake_Buffer[Pos+1]) PlotPoint(Pos,Snake_Bufferda,Snake_Bufferdb,Snake_Buffer);
    }
   while(Pos>0)
   {
      Snake_Buffer[Pos]=SnakeFirstCalc(Pos);
      Pos--;
       Snake_Bufferua[Pos] = EMPTY_VALUE;
       Snake_Bufferub[Pos] = EMPTY_VALUE;
       Snake_Bufferda[Pos] = EMPTY_VALUE;
       Snake_Bufferdb[Pos] = EMPTY_VALUE;
         if (Snake_Buffer[Pos] > Snake_Buffer[Pos+1]) PlotPoint(Pos,Snake_Bufferua,Snake_Bufferub,Snake_Buffer);
         if (Snake_Buffer[Pos] < Snake_Buffer[Pos+1]) PlotPoint(Pos,Snake_Bufferda,Snake_Bufferdb,Snake_Buffer);
   }
   if(Pos==0) 
      Snake_Buffer[0]=iMA(NULL,0,Snake_HalfCycle,0,MODE_LWMA,PRICE_TYPICAL,0);
      Snake_Bufferua[0] = EMPTY_VALUE;
      Snake_Bufferub[0] = EMPTY_VALUE;
      Snake_Bufferda[0] = EMPTY_VALUE;
      Snake_Bufferdb[0] = EMPTY_VALUE;
         if (Snake_Buffer[0] > Snake_Buffer[0+1]) PlotPoint(Pos,Snake_Bufferua,Snake_Bufferub,Snake_Buffer);
         if (Snake_Buffer[0] < Snake_Buffer[0+1]) PlotPoint(Pos,Snake_Bufferda,Snake_Bufferdb,Snake_Buffer);
   return;
}
//----
double SnakePrice(int Shift)
{
   return((2*Close[Shift]+High[Shift]+Low[Shift])/4);
}
//----
double SnakeFirstCalc(int Shift)
{
int i, j, w;
   Snake_Sum=0.0;
   Snake_Weight=0.0;
   if(Shift<Snake_HalfCycle)
   {
      i=0;
      w=Shift+Snake_HalfCycle;
      while(w>=Shift)
      {
         i++;
         Snake_Sum=Snake_Sum+i*SnakePrice(w);
         Snake_Weight=Snake_Weight+i;
         w--;
      }
      while(w>=0)
      {
         i--;
         Snake_Sum=Snake_Sum+i*SnakePrice(w);
         Snake_Weight=Snake_Weight+i;
         w--;
      }
   }
   else
   {
      Snake_Sum_Minus=0.0;
      Snake_Sum_Plus=0.0;
      for(j=Shift-Snake_HalfCycle,i=Shift+Snake_HalfCycle,w=1;
          w<= Snake_HalfCycle; 
          j++,i--,w++)
      {
         Snake_Sum=Snake_Sum+w*(SnakePrice(i)+SnakePrice(j));
         Snake_Weight=Snake_Weight+2*w;
         Snake_Sum_Minus=Snake_Sum_Minus+SnakePrice(i);
         Snake_Sum_Plus=Snake_Sum_Plus+SnakePrice(j);
      }
      Snake_Sum=Snake_Sum+( Snake_HalfCycle+1)*SnakePrice(Shift);
      Snake_Weight=Snake_Weight+ Snake_HalfCycle+1;
      Snake_Sum_Minus=Snake_Sum_Minus+SnakePrice(Shift);
   }
   return(Snake_Sum/ Snake_Weight);
}
//----
double SnakeNextCalc(int Shift)
{
   Snake_Sum_Plus=Snake_Sum_Plus+SnakePrice(Shift-Snake_HalfCycle);
   Snake_Sum=Snake_Sum-Snake_Sum_Minus+Snake_Sum_Plus;
   Snake_Sum_Minus=Snake_Sum_Minus-SnakePrice(Shift+Snake_HalfCycle+1)+SnakePrice(Shift);
   Snake_Sum_Plus=Snake_Sum_Plus-SnakePrice(Shift);
   return(Snake_Sum/Snake_Weight);
}
//----
void CleanPoint(int Pos,double& first[],double& second[])
{
   if ((second[Pos]  != EMPTY_VALUE) && (second[Pos+1] != EMPTY_VALUE))
        second[Pos+1] = EMPTY_VALUE;
   else
      if ((first[Pos] != EMPTY_VALUE) && (first[Pos+1] != EMPTY_VALUE) && (first[Pos+2] == EMPTY_VALUE))
          first[Pos+1] = EMPTY_VALUE;
}
//----
void PlotPoint(int Pos,double& first[],double& second[],double& from[])
{
   if (first[Pos+1] == EMPTY_VALUE)
      {
         if (first[Pos+2] == EMPTY_VALUE) {
                first[Pos]   = from[Pos];
                first[Pos+1] = from[Pos+1];
                second[Pos]  = EMPTY_VALUE;
            }
         else {
                second[Pos]   =  from[Pos];
                second[Pos+1] =  from[Pos+1];
                first[Pos]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[Pos]   = from[Pos];
         second[Pos]  = EMPTY_VALUE;
      }
}