//+------------------------------------------------------------------+
//|                                       Ind-WSO+WRO+Trend Line.mq4 |
//|                    Copyright  2004, http://www.expert-mt4.nm.ru |
//|                                      http://www.expert-mt4.nm.ru |
//+------------------------------------------------------------------+
#property copyright "nsi2000"
#property link      "http://www.expert-mt4.nm.ru"

#property indicator_chart_window





extern string timeFrame = "Current time frame";
extern int    nPeriod   = 9;



int    TimeFrame;

//
//
//
//
//

int init()
  {
   TimeFrame = stringToTimeFrame(timeFrame);
   for(int cnt=0; cnt<=5; cnt++)
    {
      ObjectCreate("WSO-"+cnt,OBJ_HLINE,0,0,0);
      ObjectSet("WSO-"+cnt,OBJPROP_COLOR,Green);
   if(cnt<5)
      {
      ObjectCreate("Trend DN-"+cnt,OBJ_TREND,0,0,0,0,0);
      ObjectSet("Trend DN-"+cnt,OBJPROP_COLOR,Green);
      }

      ObjectCreate("WRO-"+cnt,OBJ_HLINE,0,0,0);
      ObjectSet("WRO-"+cnt,OBJPROP_COLOR,Red);
   if(cnt<5)
      {
      ObjectCreate("Trend UP-"+cnt,OBJ_TREND,0,0,0,0,0);
      ObjectSet("Trend Up-"+cnt,OBJPROP_COLOR,Red);
      }
    }

   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int deinit()
  {

   for(int cnt=0; cnt<=5; cnt++)
      {
      ObjectDelete("Trend UP-"+cnt);
      ObjectDelete("Trend DN-"+cnt);
      ObjectDelete("WSO-"+cnt);
      ObjectDelete("WRO-"+cnt);
      }

   return(0);
  }
//+------------------------------------------------------------------+
//|     
//                          
//+------------------------------------------------------------------+
//

int start()
  {
   double r1,r2,r3,r4,r5,r6;
   int rt1,rt2,rt3,rt4,rt5,rt6;
   double s1,s2,s3,s4,s5,s6;
   int st1,st2,st3,st4,st5,st6;
   
   int counted_bars=IndicatorCounted();
   int limit,i;
   
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
      limit=MathMax(MathMin(Bars-counted_bars,Bars-1),TimeFrame/Period());   
      

   //
   //
   //
   //
   //
   
   for (i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,TimeFrame,Time[i]);
      if (Low[y+(nPeriod-1)/2] == Low[iLowest(NULL,TimeFrame,MODE_LOW,nPeriod,y)])
      {
        s6=s5; s5=s4; s4=s3; s3=s2; s2=s1; s1=Low[i+(nPeriod-1)/2];
        st6=st5; st5=st4; st4=st3; st3=st2; st2=st1; st1= i+(nPeriod-1)/2;
     }
      
     if (High[y+(nPeriod-1)/2] == High[iHighest(NULL,TimeFrame,MODE_HIGH,nPeriod,y)])
     {
        r6=r5; r5=r4; r4=r3; r3=r2; r2=r1; r1=High[i+(nPeriod-1)/2];
        rt6=rt5; rt5=rt4; rt4=rt3; rt3=rt2; rt2=rt1; rt1= i+(nPeriod-1)/2;
     }
  } 
//
//
//
//
//

//ObjectMove("WSO-0",0,Time[st1],s1);
ObjectMove("Trend DN-0",1,Time[st1],s1);
ObjectMove("Trend DN-0",0,Time[st2],s2);
//ObjectMove("WSO-1",0,Time[st2],s2);
//ObjectMove("Trend DN-1",1,Time[st2],s2);
//ObjectMove("Trend DN-1",0,Time[st3],s3);
//ObjectMove("WSO-2",0,Time[st3],s3);
//ObjectMove("Trend DN-2",1,Time[st3],s3);
//ObjectMove("Trend DN-2",0,Time[st4],s4);
//ObjectMove("WSO-3",0,Time[st4],s4);
//ObjectMove("Trend DN-3",1,Time[st4],s4);
//ObjectMove("Trend DN-3",0,Time[st5],s5);
//ObjectMove("WSO-4",0,Time[st5],s5);
//ObjectMove("Trend DN-4",1,Time[st5],s5);
//ObjectMove("Trend DN-4",0,Time[st6],s6);
//ObjectMove("WSO-5",0,Time[st6],s6);

//
//
//
//
//

//ObjectMove("WRO-0",0,Time[rt1],r1);
ObjectMove("Trend UP-0",1,Time[rt1],r1);
ObjectMove("Trend UP-0",0,Time[rt2],r2);
//ObjectMove("WRO-1",0,Time[rt2],r2);
//ObjectMove("Trend UP-1",1,Time[rt2],r2);
//ObjectMove("Trend UP-1",0,Time[rt3],r3);
//ObjectMove("WRO-2",0,Time[rt3],r3);
//ObjectMove("Trend UP-2",1,Time[rt3],r3);
//ObjectMove("Trend UP-2",0,Time[rt4],r4);
//ObjectMove("WRO-3",0,Time[rt4],r4);
//ObjectMove("Trend UP-3",1,Time[rt4],r4);
//ObjectMove("Trend UP-3",0,Time[rt5],r5);
//ObjectMove("WRO-4",0,Time[rt5],r5);
//ObjectMove("Trend UP-4",1,Time[rt5],r5);
//ObjectMove("Trend UP-4",0,Time[rt6],r6);
//ObjectMove("WRO-5",0,Time[rt6],r6);

   return(0);
  }
//--------------------------------------------------+ 

//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   int tf=0;
       tfs = StringUpperCase(tfs);
         if (tfs=="M1" || tfs=="1")     tf=PERIOD_M1;
         if (tfs=="M5" || tfs=="5")     tf=PERIOD_M5;
         if (tfs=="M15"|| tfs=="15")    tf=PERIOD_M15;
         if (tfs=="M30"|| tfs=="30")    tf=PERIOD_M30;
         if (tfs=="H1" || tfs=="60")    tf=PERIOD_H1;
         if (tfs=="H4" || tfs=="240")   tf=PERIOD_H4;
         if (tfs=="D1" || tfs=="1440")  tf=PERIOD_D1;
         if (tfs=="W1" || tfs=="10080") tf=PERIOD_W1;
         if (tfs=="MN" || tfs=="43200") tf=PERIOD_MN1;
         if (tf<Period()) tf=Period();
  return(tf);
}

//
//
//
//
//

string StringUpperCase(string str)
{
   string   s = str;
   int      lenght = StringLen(str) - 1;
   int      tchar;
   
   while(lenght >= 0)
      {
         tchar = StringGetChar(s, lenght);
         
         //
         //
         //
         //
         //
         
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                  s = StringSetChar(s, lenght, tchar - 32);
          else 
              if(tchar > -33 && tchar < 0)
                  s = StringSetChar(s, lenght, tchar + 224);
                  
         //
         //
         //
         //
         //
                                 
         lenght--;
   }
   
   //
   //
   //
   //
   //
   
   return(s);
} 