
// FOR THOSE OF YOU THAT IMPROVE UPON THIS HERE CODE I ASK YOU ONE THING
// PLEASE POST A COPY UP ON THE FOREX FORUMS FOR YOUR FELLOW TRADERS

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1 CLR_NONE
#property indicator_color2 Navy//DarkGreen
#property indicator_color3 OrangeRed//SaddleBrown//Maroon
#property indicator_width2 10
#property indicator_width3 10

#property indicator_levelcolor CLR_NONE
#property indicator_maximum  1.777
#property indicator_minimum -1.777

extern bool MsgAlerts=false;
extern bool SoundAlerts=false;
extern string SoundAlertFile="alert.wave";
extern bool eMailAlerts=false;

int LastAlertBar; //Alert code


extern int BarsCount = 16;
double g_ibuf_80[];
double g_ibuf_84[];
double g_ibuf_88[];


int init() {
   SetIndexStyle(0, DRAW_NONE);
   SetIndexStyle(1, DRAW_HISTOGRAM);
   SetIndexStyle(2, DRAW_HISTOGRAM);
   IndicatorDigits(Digits + 0);
   SetIndexBuffer(0, g_ibuf_80);
   SetIndexBuffer(1, g_ibuf_84);
   SetIndexBuffer(2, g_ibuf_88);
   IndicatorShortName("X:-)");//trendline_fast");
   SetIndexLabel(0, NULL);
   SetIndexLabel(1, NULL);
   SetIndexLabel(2, NULL);
   return (0);
}

int start() {
   double ld_8;
   double ld_16;
   int bars = IndicatorCounted();
   double ld_32 = 0;
   double ld_40 = 0;
   double ld_64 = 0;
   double Price.Average;
   double Price.Lowest = 0;
   double Price.Highest = 0;
   if (bars > 0) bars--;
   int limit = Bars - bars;
   
   for (int i = 0; i < limit; i++) {
      Price.Highest = High[iHighest(NULL, 0, MODE_HIGH, BarsCount, i)];
      Price.Lowest = Low[iLowest(NULL, 0, MODE_LOW, BarsCount, i)];
      Price.Average = (High[i] + Low[i]) / 2.0;
      ld_32 = 0.66 * ((Price.Average - Price.Lowest) / (Price.Highest - Price.Lowest) - 0.5) + 0.67 * ld_40;
      ld_32 = MathMin(MathMax(ld_32, -0.999), 0.999);
      g_ibuf_80[i] = MathLog((ld_32 + 1.0) / (1 - ld_32)) / 2.0 + ld_64 / 2.0;
      ld_40 = ld_32;
      ld_64 = g_ibuf_80[i];
   }
   
   bool li_108 = TRUE;
   for (i = limit - 2; i >= 0; i--) {
      ld_16 = g_ibuf_80[i+1];
      ld_8 = g_ibuf_80[i + 2];
      if ((ld_16 < 0.0 && ld_8 > 0.0) || ld_16 < 0.0)
      { 
      li_108 = FALSE;
      
      //Start Alert code
       if(ld_16<0.0 && ld_8>0.0)
       {
         string base=Symbol()+", TF:" + TF2Str(Period());
         string Subj=base+", Trend Is Now Down, value: "+ld_16;
         string Msg=Subj+" @ "+TimeToStr(TimeLocal(),TIME_SECONDS);
         if(Bars>LastAlertBar)
         {
         LastAlertBar=Bars;
         DoAlerts(Msg,Subj);
         }
        }
       //End Alert code
      }
      if ((ld_16 > 0.0 && ld_8 < 0.0) || ld_16 > 0.0)
      {
         li_108 = TRUE;
        
        // Start Alert code
         if(ld_16>0.0 && ld_8<0.0)
        {
          base=Symbol()+", TF:"+TF2Str(Period());
          Subj=base+", Trend Is Now Up, value: "+ld_16;
          Msg=Subj+" @ "+TimeToStr(TimeLocal(),TIME_SECONDS);
          if(Bars>LastAlertBar)
         {
           LastAlertBar=Bars;
           DoAlerts(Msg,Subj);
         }
        }
       //End Alert code  
      }
      if (!li_108 ) {
         g_ibuf_88[i] = ld_16;
         g_ibuf_84[i] = 0.0;
         
         
      } else {
         g_ibuf_84[i] = ld_16;
         g_ibuf_88[i] = 0.0;
        
      }
   }
   return (0);
}

//Start Alert functions
void DoAlerts(string msgText,string eMailSub)
  {
   if(MsgAlerts) Alert(msgText);
   if(SoundAlerts) PlaySound(SoundAlertFile);
   if(eMailAlerts) SendMail(eMailSub,msgText);
  }
  
  string TF2Str(int period)
  {
      switch(period)
      {
         case PERIOD_M1: return("M1");
         case PERIOD_M5: return("M5");
         case PERIOD_M15: return("M15");
         case PERIOD_M30: return("M30");
         case PERIOD_H1: return("H1");
         case PERIOD_H4: return("H4");
         case PERIOD_D1: return("D1");
         case PERIOD_W1: return("W1");
         case PERIOD_MN1: return("MN1");
       }
       return(Period());
   }
   
 //End Alert functions