//+------------------------------------------------------------------+
//|                                  #Soho_Tenkan_Vs_Kijun_Histo.mq4 |
//|                      Copyright  2010, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_separate_window
#property indicator_minimum 0
#property indicator_maximum 1

#property  indicator_buffers 3
#property  indicator_color1  Yellow
#property  indicator_color2  Red
#property  indicator_color3  Blue
#property indicator_width1 4
#property indicator_width2 4

#property indicator_width3 4


//---- indicator parameters      
extern int Tenkan=8;
extern int Kijun=24;
extern int Senkou=48;

//---- indicator buffers
double   ExtBuffer1[];
double   ExtBuffer2[];
double   ExtBuffer3[];

//+------------------------------------------------------------------+
//| Custom indi
//cator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {//----//---- drawing settings

   SetIndexStyle (0,DRAW_HISTOGRAM, EMPTY,4,Yellow);
   SetIndexBuffer(0,ExtBuffer1);
   SetIndexStyle (1,DRAW_HISTOGRAM, EMPTY,4,Red);
   SetIndexBuffer(1,ExtBuffer2); 
   SetIndexStyle (2,DRAW_HISTOGRAM, EMPTY,4,Blue);
   SetIndexBuffer(2,ExtBuffer3); 
   
  IndicatorShortName("Soho_Price_Vs_KUMO_Histo "+Tenkan+", Kijun "+Kijun+", Senkou "+Senkou+" ");
   SetIndexLabel(0,"Bullish : Close is ABOVE Kumo");
  SetIndexLabel(1,"Bearish : Close is BELOW Kumo");
  SetIndexLabel(2,"Inside : Close is INSIDE Kumo");
   
//---- initialization done
   
   
  
  
//----
   return(0);
  }


  
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int limit;
   int counted_bars=IndicatorCounted();
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
//---- macd counted in the 1st buffer

   for(int i=0; i<limit; i++)
     
       if (iMA(NULL,0,1,0,0,0,i)< iIchimoku(NULL,0,Tenkan,Kijun,Senkou,MODE_SENKOUSPANB,i)&& iMA(NULL,0,1,0,0,0,i)< iIchimoku(NULL,0,Tenkan,Kijun,Senkou,MODE_SENKOUSPANA,i))
        {
        ExtBuffer2[i]=1;           
        }
       else 
       if (iMA(NULL,0,1,0,0,0,i)> iIchimoku(NULL,0,Tenkan,Kijun,Senkou,MODE_SENKOUSPANB,i)&& iMA(NULL,0,1,0,0,0,i)> iIchimoku(NULL,0,Tenkan,Kijun,Senkou,MODE_SENKOUSPANA,i))
        {            
                ExtBuffer1[i]=1;           
        }
       else 
        
        ExtBuffer3[i]=1;
        
       
      
   return(0);
  }
//+------------------------------------------------------------------+